#pragma once

#include <typed-geometry/functions/swizzling/swizzling-basic.hh>

// usage:
// using namespace tg::swizzling;
// v[xz] = {1, 2};

namespace tg::swizzling
{
constexpr swizzler<0, 0> xx;
constexpr swizzler<0, 1> xy;
constexpr swizzler<0, 2> xz;
constexpr swizzler<0, 3> xw;
constexpr swizzler<1, 0> yx;
constexpr swizzler<1, 1> yy;
constexpr swizzler<1, 2> yz;
constexpr swizzler<1, 3> yw;
constexpr swizzler<2, 0> zx;
constexpr swizzler<2, 1> zy;
constexpr swizzler<2, 2> zz;
constexpr swizzler<2, 3> zw;
constexpr swizzler<3, 0> wx;
constexpr swizzler<3, 1> wy;
constexpr swizzler<3, 2> wz;
constexpr swizzler<3, 3> ww;

constexpr swizzler<0, 0, 0> xxx;
constexpr swizzler<0, 0, 1> xxy;
constexpr swizzler<0, 0, 2> xxz;
constexpr swizzler<0, 0, 3> xxw;
constexpr swizzler<0, 1, 0> xyx;
constexpr swizzler<0, 1, 1> xyy;
constexpr swizzler<0, 1, 2> xyz;
constexpr swizzler<0, 1, 3> xyw;
constexpr swizzler<0, 2, 0> xzx;
constexpr swizzler<0, 2, 1> xzy;
constexpr swizzler<0, 2, 2> xzz;
constexpr swizzler<0, 2, 3> xzw;
constexpr swizzler<0, 3, 0> xwx;
constexpr swizzler<0, 3, 1> xwy;
constexpr swizzler<0, 3, 2> xwz;
constexpr swizzler<0, 3, 3> xww;
constexpr swizzler<1, 0, 0> yxx;
constexpr swizzler<1, 0, 1> yxy;
constexpr swizzler<1, 0, 2> yxz;
constexpr swizzler<1, 0, 3> yxw;
constexpr swizzler<1, 1, 0> yyx;
constexpr swizzler<1, 1, 1> yyy;
constexpr swizzler<1, 1, 2> yyz;
constexpr swizzler<1, 1, 3> yyw;
constexpr swizzler<1, 2, 0> yzx;
constexpr swizzler<1, 2, 1> yzy;
constexpr swizzler<1, 2, 2> yzz;
constexpr swizzler<1, 2, 3> yzw;
constexpr swizzler<1, 3, 0> ywx;
constexpr swizzler<1, 3, 1> ywy;
constexpr swizzler<1, 3, 2> ywz;
constexpr swizzler<1, 3, 3> yww;
constexpr swizzler<2, 0, 0> zxx;
constexpr swizzler<2, 0, 1> zxy;
constexpr swizzler<2, 0, 2> zxz;
constexpr swizzler<2, 0, 3> zxw;
constexpr swizzler<2, 1, 0> zyx;
constexpr swizzler<2, 1, 1> zyy;
constexpr swizzler<2, 1, 2> zyz;
constexpr swizzler<2, 1, 3> zyw;
constexpr swizzler<2, 2, 0> zzx;
constexpr swizzler<2, 2, 1> zzy;
constexpr swizzler<2, 2, 2> zzz;
constexpr swizzler<2, 2, 3> zzw;
constexpr swizzler<2, 3, 0> zwx;
constexpr swizzler<2, 3, 1> zwy;
constexpr swizzler<2, 3, 2> zwz;
constexpr swizzler<2, 3, 3> zww;
constexpr swizzler<3, 0, 0> wxx;
constexpr swizzler<3, 0, 1> wxy;
constexpr swizzler<3, 0, 2> wxz;
constexpr swizzler<3, 0, 3> wxw;
constexpr swizzler<3, 1, 0> wyx;
constexpr swizzler<3, 1, 1> wyy;
constexpr swizzler<3, 1, 2> wyz;
constexpr swizzler<3, 1, 3> wyw;
constexpr swizzler<3, 2, 0> wzx;
constexpr swizzler<3, 2, 1> wzy;
constexpr swizzler<3, 2, 2> wzz;
constexpr swizzler<3, 2, 3> wzw;
constexpr swizzler<3, 3, 0> wwx;
constexpr swizzler<3, 3, 1> wwy;
constexpr swizzler<3, 3, 2> wwz;
constexpr swizzler<3, 3, 3> www;

constexpr swizzler<0, 0, 0, 0> xxxx;
constexpr swizzler<0, 0, 0, 1> xxxy;
constexpr swizzler<0, 0, 0, 2> xxxz;
constexpr swizzler<0, 0, 0, 3> xxxw;
constexpr swizzler<0, 0, 1, 0> xxyx;
constexpr swizzler<0, 0, 1, 1> xxyy;
constexpr swizzler<0, 0, 1, 2> xxyz;
constexpr swizzler<0, 0, 1, 3> xxyw;
constexpr swizzler<0, 0, 2, 0> xxzx;
constexpr swizzler<0, 0, 2, 1> xxzy;
constexpr swizzler<0, 0, 2, 2> xxzz;
constexpr swizzler<0, 0, 2, 3> xxzw;
constexpr swizzler<0, 0, 3, 0> xxwx;
constexpr swizzler<0, 0, 3, 1> xxwy;
constexpr swizzler<0, 0, 3, 2> xxwz;
constexpr swizzler<0, 0, 3, 3> xxww;
constexpr swizzler<0, 1, 0, 0> xyxx;
constexpr swizzler<0, 1, 0, 1> xyxy;
constexpr swizzler<0, 1, 0, 2> xyxz;
constexpr swizzler<0, 1, 0, 3> xyxw;
constexpr swizzler<0, 1, 1, 0> xyyx;
constexpr swizzler<0, 1, 1, 1> xyyy;
constexpr swizzler<0, 1, 1, 2> xyyz;
constexpr swizzler<0, 1, 1, 3> xyyw;
constexpr swizzler<0, 1, 2, 0> xyzx;
constexpr swizzler<0, 1, 2, 1> xyzy;
constexpr swizzler<0, 1, 2, 2> xyzz;
constexpr swizzler<0, 1, 2, 3> xyzw;
constexpr swizzler<0, 1, 3, 0> xywx;
constexpr swizzler<0, 1, 3, 1> xywy;
constexpr swizzler<0, 1, 3, 2> xywz;
constexpr swizzler<0, 1, 3, 3> xyww;
constexpr swizzler<0, 2, 0, 0> xzxx;
constexpr swizzler<0, 2, 0, 1> xzxy;
constexpr swizzler<0, 2, 0, 2> xzxz;
constexpr swizzler<0, 2, 0, 3> xzxw;
constexpr swizzler<0, 2, 1, 0> xzyx;
constexpr swizzler<0, 2, 1, 1> xzyy;
constexpr swizzler<0, 2, 1, 2> xzyz;
constexpr swizzler<0, 2, 1, 3> xzyw;
constexpr swizzler<0, 2, 2, 0> xzzx;
constexpr swizzler<0, 2, 2, 1> xzzy;
constexpr swizzler<0, 2, 2, 2> xzzz;
constexpr swizzler<0, 2, 2, 3> xzzw;
constexpr swizzler<0, 2, 3, 0> xzwx;
constexpr swizzler<0, 2, 3, 1> xzwy;
constexpr swizzler<0, 2, 3, 2> xzwz;
constexpr swizzler<0, 2, 3, 3> xzww;
constexpr swizzler<0, 3, 0, 0> xwxx;
constexpr swizzler<0, 3, 0, 1> xwxy;
constexpr swizzler<0, 3, 0, 2> xwxz;
constexpr swizzler<0, 3, 0, 3> xwxw;
constexpr swizzler<0, 3, 1, 0> xwyx;
constexpr swizzler<0, 3, 1, 1> xwyy;
constexpr swizzler<0, 3, 1, 2> xwyz;
constexpr swizzler<0, 3, 1, 3> xwyw;
constexpr swizzler<0, 3, 2, 0> xwzx;
constexpr swizzler<0, 3, 2, 1> xwzy;
constexpr swizzler<0, 3, 2, 2> xwzz;
constexpr swizzler<0, 3, 2, 3> xwzw;
constexpr swizzler<0, 3, 3, 0> xwwx;
constexpr swizzler<0, 3, 3, 1> xwwy;
constexpr swizzler<0, 3, 3, 2> xwwz;
constexpr swizzler<0, 3, 3, 3> xwww;
constexpr swizzler<1, 0, 0, 0> yxxx;
constexpr swizzler<1, 0, 0, 1> yxxy;
constexpr swizzler<1, 0, 0, 2> yxxz;
constexpr swizzler<1, 0, 0, 3> yxxw;
constexpr swizzler<1, 0, 1, 0> yxyx;
constexpr swizzler<1, 0, 1, 1> yxyy;
constexpr swizzler<1, 0, 1, 2> yxyz;
constexpr swizzler<1, 0, 1, 3> yxyw;
constexpr swizzler<1, 0, 2, 0> yxzx;
constexpr swizzler<1, 0, 2, 1> yxzy;
constexpr swizzler<1, 0, 2, 2> yxzz;
constexpr swizzler<1, 0, 2, 3> yxzw;
constexpr swizzler<1, 0, 3, 0> yxwx;
constexpr swizzler<1, 0, 3, 1> yxwy;
constexpr swizzler<1, 0, 3, 2> yxwz;
constexpr swizzler<1, 0, 3, 3> yxww;
constexpr swizzler<1, 1, 0, 0> yyxx;
constexpr swizzler<1, 1, 0, 1> yyxy;
constexpr swizzler<1, 1, 0, 2> yyxz;
constexpr swizzler<1, 1, 0, 3> yyxw;
constexpr swizzler<1, 1, 1, 0> yyyx;
constexpr swizzler<1, 1, 1, 1> yyyy;
constexpr swizzler<1, 1, 1, 2> yyyz;
constexpr swizzler<1, 1, 1, 3> yyyw;
constexpr swizzler<1, 1, 2, 0> yyzx;
constexpr swizzler<1, 1, 2, 1> yyzy;
constexpr swizzler<1, 1, 2, 2> yyzz;
constexpr swizzler<1, 1, 2, 3> yyzw;
constexpr swizzler<1, 1, 3, 0> yywx;
constexpr swizzler<1, 1, 3, 1> yywy;
constexpr swizzler<1, 1, 3, 2> yywz;
constexpr swizzler<1, 1, 3, 3> yyww;
constexpr swizzler<1, 2, 0, 0> yzxx;
constexpr swizzler<1, 2, 0, 1> yzxy;
constexpr swizzler<1, 2, 0, 2> yzxz;
constexpr swizzler<1, 2, 0, 3> yzxw;
constexpr swizzler<1, 2, 1, 0> yzyx;
constexpr swizzler<1, 2, 1, 1> yzyy;
constexpr swizzler<1, 2, 1, 2> yzyz;
constexpr swizzler<1, 2, 1, 3> yzyw;
constexpr swizzler<1, 2, 2, 0> yzzx;
constexpr swizzler<1, 2, 2, 1> yzzy;
constexpr swizzler<1, 2, 2, 2> yzzz;
constexpr swizzler<1, 2, 2, 3> yzzw;
constexpr swizzler<1, 2, 3, 0> yzwx;
constexpr swizzler<1, 2, 3, 1> yzwy;
constexpr swizzler<1, 2, 3, 2> yzwz;
constexpr swizzler<1, 2, 3, 3> yzww;
constexpr swizzler<1, 3, 0, 0> ywxx;
constexpr swizzler<1, 3, 0, 1> ywxy;
constexpr swizzler<1, 3, 0, 2> ywxz;
constexpr swizzler<1, 3, 0, 3> ywxw;
constexpr swizzler<1, 3, 1, 0> ywyx;
constexpr swizzler<1, 3, 1, 1> ywyy;
constexpr swizzler<1, 3, 1, 2> ywyz;
constexpr swizzler<1, 3, 1, 3> ywyw;
constexpr swizzler<1, 3, 2, 0> ywzx;
constexpr swizzler<1, 3, 2, 1> ywzy;
constexpr swizzler<1, 3, 2, 2> ywzz;
constexpr swizzler<1, 3, 2, 3> ywzw;
constexpr swizzler<1, 3, 3, 0> ywwx;
constexpr swizzler<1, 3, 3, 1> ywwy;
constexpr swizzler<1, 3, 3, 2> ywwz;
constexpr swizzler<1, 3, 3, 3> ywww;
constexpr swizzler<2, 0, 0, 0> zxxx;
constexpr swizzler<2, 0, 0, 1> zxxy;
constexpr swizzler<2, 0, 0, 2> zxxz;
constexpr swizzler<2, 0, 0, 3> zxxw;
constexpr swizzler<2, 0, 1, 0> zxyx;
constexpr swizzler<2, 0, 1, 1> zxyy;
constexpr swizzler<2, 0, 1, 2> zxyz;
constexpr swizzler<2, 0, 1, 3> zxyw;
constexpr swizzler<2, 0, 2, 0> zxzx;
constexpr swizzler<2, 0, 2, 1> zxzy;
constexpr swizzler<2, 0, 2, 2> zxzz;
constexpr swizzler<2, 0, 2, 3> zxzw;
constexpr swizzler<2, 0, 3, 0> zxwx;
constexpr swizzler<2, 0, 3, 1> zxwy;
constexpr swizzler<2, 0, 3, 2> zxwz;
constexpr swizzler<2, 0, 3, 3> zxww;
constexpr swizzler<2, 1, 0, 0> zyxx;
constexpr swizzler<2, 1, 0, 1> zyxy;
constexpr swizzler<2, 1, 0, 2> zyxz;
constexpr swizzler<2, 1, 0, 3> zyxw;
constexpr swizzler<2, 1, 1, 0> zyyx;
constexpr swizzler<2, 1, 1, 1> zyyy;
constexpr swizzler<2, 1, 1, 2> zyyz;
constexpr swizzler<2, 1, 1, 3> zyyw;
constexpr swizzler<2, 1, 2, 0> zyzx;
constexpr swizzler<2, 1, 2, 1> zyzy;
constexpr swizzler<2, 1, 2, 2> zyzz;
constexpr swizzler<2, 1, 2, 3> zyzw;
constexpr swizzler<2, 1, 3, 0> zywx;
constexpr swizzler<2, 1, 3, 1> zywy;
constexpr swizzler<2, 1, 3, 2> zywz;
constexpr swizzler<2, 1, 3, 3> zyww;
constexpr swizzler<2, 2, 0, 0> zzxx;
constexpr swizzler<2, 2, 0, 1> zzxy;
constexpr swizzler<2, 2, 0, 2> zzxz;
constexpr swizzler<2, 2, 0, 3> zzxw;
constexpr swizzler<2, 2, 1, 0> zzyx;
constexpr swizzler<2, 2, 1, 1> zzyy;
constexpr swizzler<2, 2, 1, 2> zzyz;
constexpr swizzler<2, 2, 1, 3> zzyw;
constexpr swizzler<2, 2, 2, 0> zzzx;
constexpr swizzler<2, 2, 2, 1> zzzy;
constexpr swizzler<2, 2, 2, 2> zzzz;
constexpr swizzler<2, 2, 2, 3> zzzw;
constexpr swizzler<2, 2, 3, 0> zzwx;
constexpr swizzler<2, 2, 3, 1> zzwy;
constexpr swizzler<2, 2, 3, 2> zzwz;
constexpr swizzler<2, 2, 3, 3> zzww;
constexpr swizzler<2, 3, 0, 0> zwxx;
constexpr swizzler<2, 3, 0, 1> zwxy;
constexpr swizzler<2, 3, 0, 2> zwxz;
constexpr swizzler<2, 3, 0, 3> zwxw;
constexpr swizzler<2, 3, 1, 0> zwyx;
constexpr swizzler<2, 3, 1, 1> zwyy;
constexpr swizzler<2, 3, 1, 2> zwyz;
constexpr swizzler<2, 3, 1, 3> zwyw;
constexpr swizzler<2, 3, 2, 0> zwzx;
constexpr swizzler<2, 3, 2, 1> zwzy;
constexpr swizzler<2, 3, 2, 2> zwzz;
constexpr swizzler<2, 3, 2, 3> zwzw;
constexpr swizzler<2, 3, 3, 0> zwwx;
constexpr swizzler<2, 3, 3, 1> zwwy;
constexpr swizzler<2, 3, 3, 2> zwwz;
constexpr swizzler<2, 3, 3, 3> zwww;
constexpr swizzler<3, 0, 0, 0> wxxx;
constexpr swizzler<3, 0, 0, 1> wxxy;
constexpr swizzler<3, 0, 0, 2> wxxz;
constexpr swizzler<3, 0, 0, 3> wxxw;
constexpr swizzler<3, 0, 1, 0> wxyx;
constexpr swizzler<3, 0, 1, 1> wxyy;
constexpr swizzler<3, 0, 1, 2> wxyz;
constexpr swizzler<3, 0, 1, 3> wxyw;
constexpr swizzler<3, 0, 2, 0> wxzx;
constexpr swizzler<3, 0, 2, 1> wxzy;
constexpr swizzler<3, 0, 2, 2> wxzz;
constexpr swizzler<3, 0, 2, 3> wxzw;
constexpr swizzler<3, 0, 3, 0> wxwx;
constexpr swizzler<3, 0, 3, 1> wxwy;
constexpr swizzler<3, 0, 3, 2> wxwz;
constexpr swizzler<3, 0, 3, 3> wxww;
constexpr swizzler<3, 1, 0, 0> wyxx;
constexpr swizzler<3, 1, 0, 1> wyxy;
constexpr swizzler<3, 1, 0, 2> wyxz;
constexpr swizzler<3, 1, 0, 3> wyxw;
constexpr swizzler<3, 1, 1, 0> wyyx;
constexpr swizzler<3, 1, 1, 1> wyyy;
constexpr swizzler<3, 1, 1, 2> wyyz;
constexpr swizzler<3, 1, 1, 3> wyyw;
constexpr swizzler<3, 1, 2, 0> wyzx;
constexpr swizzler<3, 1, 2, 1> wyzy;
constexpr swizzler<3, 1, 2, 2> wyzz;
constexpr swizzler<3, 1, 2, 3> wyzw;
constexpr swizzler<3, 1, 3, 0> wywx;
constexpr swizzler<3, 1, 3, 1> wywy;
constexpr swizzler<3, 1, 3, 2> wywz;
constexpr swizzler<3, 1, 3, 3> wyww;
constexpr swizzler<3, 2, 0, 0> wzxx;
constexpr swizzler<3, 2, 0, 1> wzxy;
constexpr swizzler<3, 2, 0, 2> wzxz;
constexpr swizzler<3, 2, 0, 3> wzxw;
constexpr swizzler<3, 2, 1, 0> wzyx;
constexpr swizzler<3, 2, 1, 1> wzyy;
constexpr swizzler<3, 2, 1, 2> wzyz;
constexpr swizzler<3, 2, 1, 3> wzyw;
constexpr swizzler<3, 2, 2, 0> wzzx;
constexpr swizzler<3, 2, 2, 1> wzzy;
constexpr swizzler<3, 2, 2, 2> wzzz;
constexpr swizzler<3, 2, 2, 3> wzzw;
constexpr swizzler<3, 2, 3, 0> wzwx;
constexpr swizzler<3, 2, 3, 1> wzwy;
constexpr swizzler<3, 2, 3, 2> wzwz;
constexpr swizzler<3, 2, 3, 3> wzww;
constexpr swizzler<3, 3, 0, 0> wwxx;
constexpr swizzler<3, 3, 0, 1> wwxy;
constexpr swizzler<3, 3, 0, 2> wwxz;
constexpr swizzler<3, 3, 0, 3> wwxw;
constexpr swizzler<3, 3, 1, 0> wwyx;
constexpr swizzler<3, 3, 1, 1> wwyy;
constexpr swizzler<3, 3, 1, 2> wwyz;
constexpr swizzler<3, 3, 1, 3> wwyw;
constexpr swizzler<3, 3, 2, 0> wwzx;
constexpr swizzler<3, 3, 2, 1> wwzy;
constexpr swizzler<3, 3, 2, 2> wwzz;
constexpr swizzler<3, 3, 2, 3> wwzw;
constexpr swizzler<3, 3, 3, 0> wwwx;
constexpr swizzler<3, 3, 3, 1> wwwy;
constexpr swizzler<3, 3, 3, 2> wwwz;
constexpr swizzler<3, 3, 3, 3> wwww;
}
